# USB Access Sample for PSF Series           Ver1.00
# 対象機種はTEXIO PSFシリーズです。
# 本サンプルはWindowsでのみ動作確認となります。
# IF-60用Windows API、USBドライバのインストールが必要です。
# GUI表示はTkinterを使用しています。
# 測定に必要な時間をインターバルに指定してください。

# coding:utf-8

import tkinter as tk    # tkモジュール
import tkinter.scrolledtext
import time

import ctypes 
import sys

from time import sleep
from tkinter import ttk


PC_ADDR = 3
loopFlg = 0


def Open_clicked():
    global PC_ADDR

    btn1['state'] = tk.DISABLED
    btn2['state'] = tk.NORMAL
    btn3['state'] = tk.DISABLED
    btn4['state'] = tk.NORMAL
    btn5['state'] = tk.DISABLED
    btn6['state'] = tk.NORMAL
    btn7['state'] = tk.NORMAL
    btn8['state'] = tk.NORMAL
    btn9['state'] = tk.NORMAL
    txtRecive.delete('1.0',tk.END)

    try:
        PC_ADDR = int(txtPCADDR.get())
        c_handle = c_open(PC_ADDR)
        if c_handle > 0: 
            c_send(PC_ADDR , (ctypes.c_char_p("*cls\n".encode("utf-8"))))
            c_send(PC_ADDR , (ctypes.c_char_p("*idn?\n".encode("utf-8"))))
            txtRcv = ctypes.create_string_buffer(255)
            c_Receive(PC_ADDR , ctypes.c_int(256) ,txtRcv)
            txtRecive.insert(0. ,str(txtRcv,encoding='utf-8',errors='replace').strip('\x00') )

    except:
        txtRecive.insert(tk.END,'Device Error')
        btn1['state'] = tk.NORMAL
        btn2['state'] = tk.DISABLED
        btn3['state'] = tk.NORMAL
        btn4['state'] = tk.DISABLED
        btn5['state'] = tk.DISABLED
        btn6['state'] = tk.DISABLED
        btn7['state'] = tk.DISABLED
        btn8['state'] = tk.DISABLED
        btn9['state'] = tk.DISABLED

def Close_clicked():
    global PC_ADDR
    #global c_close
    #global c_send

    txtSend = ':OUTP 0\n'
    c_send(PC_ADDR , (ctypes.c_char_p(txtSend.encode("utf-8"))))
    txtSend = ':remote0\n'
    c_send(PC_ADDR , (ctypes.c_char_p(txtSend.encode("utf-8"))))

    btn1['state'] = tk.NORMAL
    btn2['state'] = tk.DISABLED
    btn3['state'] = tk.NORMAL
    btn4['state'] = tk.DISABLED
    btn5['state'] = tk.DISABLED
    btn6['state'] = tk.DISABLED
    btn7['state'] = tk.DISABLED
    btn8['state'] = tk.DISABLED
    btn9['state'] = tk.DISABLED
    c_close(PC_ADDR)


def interval_work():                            # インターバルで行う処理を記述
    global loopFlg
    global PC_ADDR
    
    txtSend = ':MEAS?\n'
    c_send(PC_ADDR , (ctypes.c_char_p(txtSend.encode("utf-8"))))
    txtRcv = ctypes.create_string_buffer(255)
    c_Receive(PC_ADDR , ctypes.c_int(256) ,txtRcv)
    txtRecive.insert(tk.END ,time.ctime() + '   ,' +str(txtRcv,encoding='utf-8',errors='replace').strip('\x00') )

    txtRecive.see('end')
    if (loopFlg == 1):
        root.after(500, interval_work)              # インターバルの時間(ms)を指定


def Exit_clicked():

    root.destroy()

def Loop_clicked():
    global loopFlg
    loopFlg = 1 
    btn2['state'] = tk.DISABLED
    btn4['state'] = tk.DISABLED
    btn5['state'] = tk.NORMAL
    txtRecive.delete('1.0',tk.END)

    interval_work()

def Stop_clicked():
    global loopFlg
    loopFlg = 0
    btn2['state'] = tk.NORMAL
    btn4['state'] = tk.NORMAL
    btn5['state'] = tk.DISABLED

def VOLT_clicked():
    global PC_ADDR
    txtSend = ':VOLT '+ txtVolt.get() + '\n'
    c_send(PC_ADDR , (ctypes.c_char_p(txtSend.encode("utf-8"))))

def CURR_clicked():
    global instr
    txtSend = ':CURR '+ txtCurr.get() + '\n'
    c_send(PC_ADDR , (ctypes.c_char_p(txtSend.encode("utf-8"))))

def OON_clicked():
    global PC_ADDR
    txtSend = ':OUTP 1\n'
    c_send(PC_ADDR , (ctypes.c_char_p(txtSend.encode("utf-8"))))

def OOF_clicked():
    global PC_ADDR
    txtSend = ':OUTP 0\n'
    c_send(PC_ADDR , (ctypes.c_char_p(txtSend.encode("utf-8"))))

                                              
root = tk.Tk()
root.geometry('430x320')
root.title('TEXIO API Access Sample for PSF Series')

label1 = tk.Label(root, text = 'PC ADDR:')
label1.grid(row=0, column=0,sticky = tk.E,pady=3)
txtPCADDR = ttk.Entry(root , width=4 )
txtPCADDR.delete(0,tk.END)
txtPCADDR.insert(tk.END,'3')
txtPCADDR.grid(row=0 , column=1,sticky = tk.W)

txtRecive = tkinter.scrolledtext.ScrolledText(root , width=52, height=13 )
txtRecive.grid(row=4 , column=0, columnspan = 4 ,padx=10,pady=10)

btn1 = tk.Button(master=root, text='Open'  , command=Open_clicked ,width=8)
btn1.grid(row = 1 , column=0,pady=3 )
btn2 = tk.Button(master=root, text='Close' , command=Close_clicked , state =tk.DISABLED,width=8 )
btn2.grid(row = 1 , column=1)
btn3 = tk.Button(master=root, text='Exit'  , command=Exit_clicked,width=8)
btn3.grid(row = 1 , column=3)
btn4 = tk.Button(master=root, text='LOOP'  , command=Loop_clicked, state =tk.DISABLED ,width=8)
btn4.grid(row = 3 , column=0,pady=3)
btn5 = tk.Button(master=root, text='STOP'  , command=Stop_clicked, state =tk.DISABLED ,width=8)
btn5.grid(row = 3 , column=1)
btn6 = tk.Button(master=root, text=':VOLT' , command=VOLT_clicked, state =tk.DISABLED ,width=8)
btn6.grid(row = 2 , column=0,pady=3)
btn7 = tk.Button(master=root, text=':CURR' , command=CURR_clicked, state =tk.DISABLED ,width=8)
btn7.grid(row = 2 , column=2)
btn8 = tk.Button(master=root, text='OUT ON'  , command=OON_clicked, state =tk.DISABLED ,width=8)
btn8.grid(row = 3 , column=2,pady=3)
btn9 = tk.Button(master=root, text='OUT OFF' , command=OOF_clicked, state =tk.DISABLED ,width=8)
btn9.grid(row = 3 , column=3)

txtVolt = ttk.Entry(root , width=8 )
txtVolt.delete(0,tk.END)
txtVolt.insert(tk.END,'3.0')
txtVolt.grid(row=2 , column=1)
txtCurr = ttk.Entry(root , width=8 )
txtCurr.delete(0,tk.END)
txtCurr.insert(tk.END,'1.0')
txtCurr.grid(row=2 , column=3)

# IF-60API 呼び出し定義
is64bit = sys.maxsize > 2 ** 32 
if is64bit:
    tmi_api = ctypes.windll.LoadLibrary('c:\windows\system32\IF_60.dll')
else:
    tmi_api = ctypes.windll.LoadLibrary('c:\windows\SysWOW64\IF_60.dll')

c_open = tmi_api.USB488_DeviceOpen
c_open.argtypes = [ctypes.c_int]
c_open.restype = ctypes.c_int

c_close = tmi_api.USB488_DeviceClose
c_close.argtypes = [ctypes.c_int]
c_close.restype = ctypes.c_int

c_send = tmi_api.USB488_Send
c_send.argtypes = [ctypes.c_int, ctypes.c_char_p]
c_send.restype = ctypes.c_int

c_Receive = tmi_api.USB488_Receive
c_Receive.argtypes = [ctypes.c_int, ctypes.c_int, ctypes.c_char_p]
c_Receive.restype = ctypes.c_int

root.mainloop()